export declare type Options<T> = {
    orElseGet: <U>(u: U) => U | T;
    orElseGetUndefined: () => undefined | T;
    orElseGetNull: () => null | T;
    orElseThrowDefault: (name: string) => T;
    orElseThrowCustom: (message: string) => T;
};
export declare const typeOfEqual: (expectedType: string, receivedType: string) => boolean;
export declare const isExact: <T, M extends T>(m: M, u: unknown, parseAble: boolean) => boolean;
export declare const createExact: <T, M extends T>(value: unknown, expectedType: string, receivedType: string, m: M) => Options<T>;
export declare const createOptionsForPrimitive: <T>(value: unknown, expectedType: string, receivedType: string) => Options<T>;
declare type MutableDataStructType = 'Map' | 'Array' | 'Set';
export declare const structTypeOfEqual: (value: unknown, immutable: boolean, type: MutableDataStructType) => boolean;
export declare const createOptionsForStructure: <T>(value: unknown, callBackFunction: () => T, immutable: boolean, type: MutableDataStructType) => Options<T>;
export {};
//# sourceMappingURL=util.d.ts.map