import { Options } from '../../util';
declare type ExpectedType = 'bigint' | 'number';
declare type Numeric = bigint | number;
declare const parseAsNumeric: <T extends Numeric>(value: unknown, expectedType: ExpectedType) => Options<T> & {
    inRangeOf: (min: T, max: T) => Options<T>;
    exactlyAs: <M extends T>(exact: M) => Options<M>;
};
export default parseAsNumeric;
//# sourceMappingURL=parseAsNumeric.d.ts.map