import { Options } from '../util';
declare type BooleanOptions<T extends boolean> = Options<T> & {
    orElseGetTrue: () => T | true;
    orElseGetFalse: () => T | false;
};
declare const parseAsBoolean: (value: unknown) => Options<boolean> & {
    orElseGetTrue: () => boolean;
    orElseGetFalse: () => boolean;
} & {
    exactlyAs: <T extends boolean>(t: T) => BooleanOptions<T>;
};
export default parseAsBoolean;
//# sourceMappingURL=parseAsBoolean.d.ts.map